#import "Hours_Lessons.h"

@implementation Hours_Lessons

- (id) init {
	self = [super init];
	if (self != nil) {
		Days = [[NSMutableArray alloc] init];
		lesson *less = [[lesson alloc]init]; 
		[less setLessonName:@"test" andLessonHours:@"8-10" andLessonAssignments:@"ass1"];

		
		day *Monday = [[day alloc]initWithDayName:@"Monday"];
		[Monday addLesson:less];
		[less release];
		day *tuesday = [[day alloc]initWithDayName:@"tuesday"];
		day *wednesday = [[day alloc]initWithDayName:@"Wednesday"];
		day *Thursday = [[day alloc]initWithDayName:@"Thurday"];
		day *Friday = [[day alloc]initWithDayName:@"Friday"];
		day *Saturday = [[day alloc]initWithDayName:@"Saturday"];
		day *Sunday = [[day alloc]initWithDayName:@"Sunday"];
		
		[Days addObject:Monday];
		[Days addObject:tuesday];
		[Days addObject:wednesday];
		[Days addObject:Thursday];
		[Days addObject:Friday];
		[Days addObject:Saturday];
		[Days addObject:Sunday];
		
		[Monday release];
		[tuesday release];
		[wednesday release];
		[Thursday release];
		[Friday release];
		[Saturday release];
		[Sunday release];
		
		currentDayID = 0; //Monday will be set as the first day
	}
	return self;
}

-(void)awakeFromNib
{
	printf("%i",[[daySelector selectedItem]tag]);
}

//______________________________________________________________________
-(int)numberOfRowsInTableView:(NSTableView *)tableView
{
	//printf("%i",[[[Days objectAtIndex:currentDayID] dayLessons]count] );
	return [[[Days objectAtIndex:currentDayID] dayLessons]count];
}

-(id)tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *)tableColumn
		   row:(int)row
{
	NSString *identifier = [tableColumn identifier];
	lesson *item = [[[Days objectAtIndex:currentDayID]dayLessons]objectAtIndex:row];
	//[assignmentText setString: [item lessonAssignments]];
	//[item display];
	return [item valueForKey:identifier];
}

-(void)tableView:(NSTableView *)tableView
  setObjectValue:(id)object
  forTableColumn:(NSTableColumn *)tableColumn
			 row:(int)row
{
	NSString *identifier = [tableColumn identifier];
	lesson *item = [[[Days objectAtIndex:currentDayID]dayLessons]objectAtIndex:row];
	[item takeValue:object forKey:identifier];
}

//________________________________________________________________________

-(IBAction)changeSelectedDay:(id)sender{
	currentDayID = [[daySelector selectedItem] tag];
	printf("%i",currentDayID);
	[dataContainer reloadData];
}

-(IBAction)addLesson:(id)sender
{
	lesson *less = [[lesson alloc]init];
	[less setLessonName:@"LessonName" andLessonHours:@"<0-0>" andLessonAssignments:@"<<Enter assignments for this lesson here:>>"];
	[[Days objectAtIndex:currentDayID]addLesson:less];
	[less release];
	[dataContainer reloadData];
}

-(IBAction)removeLesson:(id)sender
{
	[[[Days objectAtIndex:currentDayID]dayLessons]removeObjectAtIndex:[dataContainer selectedRow]];
	[dataContainer reloadData];
}

-(IBAction)addAssignment:(id)sender
{
	lesson *less = [[[Days objectAtIndex:currentDayID]dayLessons]objectAtIndex:[dataContainer selectedRow]];
	//[less display];
	//[less setLessonAssignments:[assignmentText string]];
	[less takeValue:[assignmentText string] forKey:@"lessonAssignments"];
	//printf("%s\n",[[assignmentText string]cStringUsingEncoding:NSUTF8StringEncoding]);
}

-(IBAction)showItemInfo:(id)sender
{
	NSString *str = [[NSString alloc] initWithString:[[[[Days objectAtIndex:currentDayID]dayLessons]objectAtIndex:[dataContainer selectedRow]]lessonAssignments]];
	
	[[[[Days objectAtIndex:currentDayID]dayLessons]objectAtIndex:[dataContainer selectedRow]]display];
	
	//[assignmentText setString:str];
}

- (void) dealloc {
	[Days release];
	[super dealloc];
}

@end
