#import "day.h"

@implementation day
- (id) init {
	self = [super init];
	if (self != nil) {
		dayName = [[NSString alloc] init];
		dayLessons = [[NSMutableArray alloc] init];
	}
	return self;
}

-(id)initWithDayName:(NSString *)theName
{
	self = [super init];
	dayName = [[NSString alloc]initWithString:theName];
	dayLessons = [[NSMutableArray alloc] init];
	return self;
}

-(void)setDayName: (NSString *)dayname
{
	[dayName release];
	dayName = [dayname retain];
}

-(void)addLesson: (lesson *)theLesson;
{
	[dayLessons addObject:theLesson];
}

-(NSString *)dayName
{
	return dayName;
}

-(NSMutableArray *)dayLessons
{
	return dayLessons;
}


-(void)showAllLessons
{
	int i;
	printf("%s\n", [dayName cStringUsingEncoding:NSUTF8StringEncoding]);
	for (i=0; i<[dayLessons count]; i++) {
		[[dayLessons objectAtIndex:i]display];
	}
}

- (void) dealloc {
	printf("day deallocating...");
	[dayName release];
	[dayLessons release];
	[super dealloc];
}


@end
